//+------------------------------------------------------------------+
//|                                                            S.mq4 |
//+------------------------------------------------------------------+
#property copyright ""
#property link      ""

#property indicator_separate_window

#property indicator_buffers 2
#property indicator_color1  White
#property indicator_color2  Black
#property indicator_maximum 1
#property indicator_minimum 0

//-------Parmetros de Entrada-------+

       int       Barras        = 3000;
extern int       Escala        = 0;
extern int       K             = 3;
extern int       D             = 3;
extern int       Suavizado     = 3;
extern int       Mtodo        = 3;
extern int       Precio        = 0;
extern int       Tamao        = 3;

//-------Buffers-------+

double Largo[];
double Corto[];

//+------------------------------------------------------------------+
//| Inicializacin                                                   |
//+------------------------------------------------------------------+

int init()
  {
   IndicatorShortName("S");

//-------Parmetros de Dibujado-------+

   IndicatorBuffers(2);
   SetIndexStyle(0,DRAW_ARROW, EMPTY, Tamao);
   SetIndexArrow(0,233);
   SetIndexBuffer(0,Largo);
   SetIndexStyle(1,DRAW_ARROW, EMPTY, Tamao);
   SetIndexArrow(1,234);
   SetIndexBuffer(1,Corto);

//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Clculo.                                                         |
//+------------------------------------------------------------------+

int start()
  {
   SetIndexDrawBegin(0,Bars-Barras+60);
   SetIndexDrawBegin(1,Bars-Barras+60);
   
   int i,counted_bars=IndicatorCounted();
   double valor1,valor2,valor3,valor4;
   
//----
   if(Bars<=35) return(0);

//-------Inicio-------+

   if(counted_bars<60)
   {
      for(i=1;i<=0;i++) Largo[Barras-i]=0.0;
      for(i=1;i<=0;i++) Corto[Barras-i]=0.0;
   }
//----
   i=Barras-60-1;

   while(i>=0)
     {

     valor1 = iStochastic(NULL,Escala,K,D,Suavizado,Mtodo,Precio,MODE_MAIN,i);            
     valor2 = iStochastic(NULL,Escala,K,D,Suavizado,Mtodo,Precio,MODE_SIGNAL,i);
     valor3 = iStochastic(NULL,Escala,K,D,Suavizado,Mtodo,Precio,MODE_MAIN,i+1);                
     valor4 = iStochastic(NULL,Escala,K,D,Suavizado,Mtodo,Precio,MODE_SIGNAL,i+1);  
      
     Largo[i] = EMPTY_VALUE;
     Corto[i] = EMPTY_VALUE;
      if      (valor1 > valor2 && valor3 < valor4) Largo[i]=0.5;
      if      (valor1 < valor2 && valor3 > valor4) Corto[i]=0.5;

      i--;
     }
   return(0);
  }
//+------------------------------------------------------------------+